
// This file combines all necessary implementations regarding the AppCore
// framework. It is a collection of #include directives including code from
// inline implementation II files. These files are .h files and hence will not
// be compiled by the IDEs by default. They do contain non-inlineable code
// though so don't treat them like normal .h files. Do not include these
// files anywhere else but here in this file.

// This file itself is a .c file which is an implementation file.

// The whole AppCore implementation has been combined into this single file
// because using only one single file speeds up the compilation considerably!



#include "../../NABase/NAConfiguration.h"
#if NA_COMPILE_GUI == 1



#include "../../NAVisual/NAImage.h"



#include "NAAppCore.h"

#include "NACoreClipboardII.h"
#include "NACoreFontII.h"
#include "NACoreImageSetII.h"
#include "NACoreKeyboardII.h"
#include "NACoreMouseII.h"
#include "NACorePreferencesII.h"

#include "UIElements/NACoreApplicationII.h"
#include "UIElements/NACoreButtonII.h"
#include "UIElements/NACoreCheckBoxII.h"
#include "UIElements/NACoreImageSpaceII.h"
#include "UIElements/NACoreLabelII.h"
#include "UIElements/NACoreMenuII.h"
#include "UIElements/NACoreMenuItemII.h"
#include "UIElements/NACoreMetalSpaceII.h"
#include "UIElements/NACoreOpenGLSpaceII.h"
#include "UIElements/NACoreRadioII.h"
#include "UIElements/NACoreScreenII.h"
#include "UIElements/NACoreSelectII.h"
#include "UIElements/NACoreSliderII.h"
#include "UIElements/NACoreSpaceII.h"
#include "UIElements/NACoreTextBoxII.h"
#include "UIElements/NACoreTextFieldII.h"
#include "UIElements/NACoreUIElementII.h"
#include "UIElements/NACoreWindowII.h"



#endif // NA_COMPILE_GUI == 1



// This is free and unencumbered software released into the public domain.

// Anyone is free to copy, modify, publish, use, compile, sell, or
// distribute this software, either in source code form or as a compiled
// binary, for any purpose, commercial or non-commercial, and by any
// means.

// In jurisdictions that recognize copyright laws, the author or authors
// of this software dedicate any and all copyright interest in the
// software to the public domain. We make this dedication for the benefit
// of the public at large and to the detriment of our heirs and
// successors. We intend this dedication to be an overt act of
// relinquishment in perpetuity of all present and future rights to this
// software under copyright law.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

// For more information, please refer to <http://unlicense.org/>
